Index: /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/extrap.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/extrap.f90	(revision 5599)
+++ /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/extrap.f90	(revision 5600)
@@ -643,65 +677,50 @@
       CALL var_move_att(td_var, tl_att)
 
-      CALL logger_warn(" EXTRAP FILL: "//&
+      CALL att_clean(tl_att)
+
+      CALL logger_info(" EXTRAP FILL: "//&
          &              TRIM(fct_str(SUM(il_detect(:,:,:))))//&
          &              " point(s) to extrapolate " )
 
       !3- extrapolate
-      DO jl=1,td_var%t_dim(4)%i_len
-        
-!            td_var%d_value(:,:,:,jl)=il_detect(:,:,:)
-         il_iter=1
-         DO WHILE( ANY(il_detect(:,:,:)==1) )
-            ! change extend value to minimize number of iteration
-            il_radius=id_radius+(il_iter/id_maxiter)
-            
-            CALL logger_debug(" EXTRAP FILL VALUE: "//&
-            &              TRIM(fct_str(SUM(il_detect(:,:,:))))//&
-            &              " points to extrapolate " )
-            
-            CALL extrap__3D(td_var%d_value(:,:,:,jl), td_var%d_fill,    &
-            &               il_detect(:,:,:),                           &
-            &               cd_method, il_radius )
-               
-            il_iter=il_iter+1
-         ENDDO
-
-      ENDDO
- 
-      IF( SUM(il_detect(:,:,:)) /= 0 )THEN
-         CALL logger_warn(" EXTRAP FILL: still "//&
-         &              TRIM(fct_str(SUM(il_detect(:,:,:))))//&
-         &              " point(s) to extrapolate " )
-      ENDIF
+      CALL extrap__3D(td_var%d_value(:,:,:,:), td_var%d_fill,    &
+      &               il_detect(:,:,:),                           &
+      &               cd_method, id_radius, id_maxiter  )
 
       DEALLOCATE(il_detect)
 
    END SUBROUTINE extrap__fill_value
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine
+   !> This subroutine compute point to be extrapolated in 3D array.
    !> 
    !> @details 
+   !> in case of 'min_error' method:<br/>
+   !>    - compute derivative in i-, j- and k- direction
+   !>    - compute minimum error coefficient (distance to center of halo)
+   !>    - compute extrapolatd values by calculated minimum error using taylor expansion 
+   !> in case of 'dist_weight' method:<br/>
+   !>    - compute distance weight coefficient (inverse of distance to center of halo) 
+   !>    - compute extrapolatd values using Inverse Distance Weighting
    !>
    !> @author J.Paul
    !> - Nov, 2013- Initial Version
    !
-   !> @param[inout] dd_value : 3D table of variable to be extrapolated
-   !> @param[in] dd_fill : FillValue of variable
-   !> @param[inout] id_detect : table of point to extrapolate
-   !> @param[in] id_ext : number of point use to compute box 
-   !> @param[in] cd_method : extrapolation method
-   !-------------------------------------------------------------------
-   !> @code
+   !> @param[inout] dd_value  3D array of variable to be extrapolated
+   !> @param[in] dd_fill      FillValue of variable
+   !> @param[inout] id_detect array of point to extrapolate
+   !> @param[in] cd_method    extrapolation method
+   !> @param[in] id_radius    radius of the halo used to compute extrapolation
+   !-------------------------------------------------------------------
    SUBROUTINE extrap__3D( dd_value, dd_fill, id_detect,&
-   &                      cd_method, id_ext )
+   &                      cd_method, id_radius, id_maxiter )
       IMPLICIT NONE
       ! Argument
-      REAL(dp)   , DIMENSION(:,:,:), INTENT(INOUT) :: dd_value
+      REAL(dp)   , DIMENSION(:,:,:,:), INTENT(INOUT) :: dd_value
       REAL(dp)   ,                   INTENT(IN   ) :: dd_fill
       INTEGER(i4), DIMENSION(:,:,:), INTENT(INOUT) :: id_detect
       CHARACTER(LEN=*),              INTENT(IN   ) :: cd_method
-      INTEGER(i4),                   INTENT(IN   ) :: id_ext
+      INTEGER(i4),                   INTENT(IN   ) :: id_radius
+      INTEGER(i4),                   INTENT(IN   ) :: id_maxiter
 
       ! local variable
@@ -712,7 +731,11 @@
       INTEGER(i4) :: il_kmin
       INTEGER(i4) :: il_kmax
-
-      INTEGER(i4), DIMENSION(3) :: il_shape
+      INTEGER(i4) :: il_iter
+      INTEGER(i4) :: il_radius
+
+      INTEGER(i4), DIMENSION(4) :: il_shape
       INTEGER(i4), DIMENSION(3) :: il_dim
+
+      INTEGER(i4), DIMENSION(:,:,:), ALLOCATABLE :: il_detect
 
       REAL(dp)   , DIMENSION(:,:,:), ALLOCATABLE :: dl_dfdx
@@ -725,187 +748,217 @@
       INTEGER(i4) :: jj
       INTEGER(i4) :: jk
+      INTEGER(i4) :: jl
       !----------------------------------------------------------------
 
       il_shape(:)=SHAPE(dd_value)
 
+      ALLOCATE( il_detect( il_shape(1), il_shape(2), il_shape(3)) )
+
       SELECT CASE(TRIM(cd_method))
-         CASE('min_error')
-
-            ALLOCATE( dl_dfdx(il_shape(1), il_shape(2), il_shape(3)) ) 
-            ALLOCATE( dl_dfdy(il_shape(1), il_shape(2), il_shape(3)) ) 
-            ALLOCATE( dl_dfdz(il_shape(1), il_shape(2), il_shape(3)) ) 
-
-
-            ! compute derivative in i-direction
-            dl_dfdx(:,:,:)=dd_fill
-            IF( il_shape(1) > 1 )THEN
-               dl_dfdx(:,:,:)=extrap_deriv_3D( dd_value(:,:,:), dd_fill, 'I' )
-            ENDIF
-
-            ! compute derivative in i-direction
-            dl_dfdy(:,:,:)=dd_fill
-            IF( il_shape(2) > 1 )THEN
-               dl_dfdy(:,:,:)=extrap_deriv_3D( dd_value(:,:,:), dd_fill, 'J' )
-            ENDIF
-               
-            ! compute derivative in i-direction
-            dl_dfdz(:,:,:)=dd_fill
-            IF( il_shape(3) > 1 )THEN
-               dl_dfdz(:,:,:)=extrap_deriv_3D( dd_value(:,:,:), dd_fill, 'K' )
-            ENDIF
-      
-            il_dim(1)=2*id_ext+1
-            IF( il_shape(1) < 2*id_ext+1 ) il_dim(1)=1
-            il_dim(2)=2*id_ext+1
-            IF( il_shape(2) < 2*id_ext+1 ) il_dim(2)=1
-            il_dim(3)=2*id_ext+1
-            IF( il_shape(3) < 2*id_ext+1 ) il_dim(3)=1
-
-            ALLOCATE( dl_coef(il_dim(1), il_dim(2), il_dim(3)) ) 
-
-            dl_coef(:,:,:)=extrap__3D_min_error_coef(dd_value( 1:il_dim(1), &
-            &                                                  1:il_dim(2), &
-            &                                                  1:il_dim(3)))
-
-            DO jk=1,il_shape(3)
-               IF( ALL(id_detect(:,:,jk) == 0) ) CYCLE
-               DO jj=1,il_shape(2)
-                  IF( ALL(id_detect(:,jj,jk) == 0) ) CYCLE
-                  DO ji=1,il_shape(1)
-
-                     IF( id_detect(ji,jj,jk) == 1 )THEN
-                       
-                        il_imin=MAX(ji-id_ext,1)
-                        il_imax=MIN(ji+id_ext,il_shape(1))
-                        IF( il_dim(1) == 1 )THEN
-                           il_imin=ji
-                           il_imax=ji
+      CASE('min_error')
+         DO jl=1,il_shape(4)
+
+            ! intitialise table of poitn to be extrapolated
+            il_detect(:,:,:)=id_detect(:,:,:)
+
+            il_iter=1
+            DO WHILE( ANY(il_detect(:,:,:)==1) )
+               ! change extend value to minimize number of iteration
+               il_radius=id_radius+(il_iter/id_maxiter)
+
+               ALLOCATE( dl_dfdx(il_shape(1), il_shape(2), il_shape(3)) ) 
+               ALLOCATE( dl_dfdy(il_shape(1), il_shape(2), il_shape(3)) ) 
+               ALLOCATE( dl_dfdz(il_shape(1), il_shape(2), il_shape(3)) ) 
+
+               ! compute derivative in i-direction
+               dl_dfdx(:,:,:)=dd_fill
+               IF( il_shape(1) > 1 )THEN
+                  dl_dfdx(:,:,:)=extrap_deriv_3D( dd_value(:,:,:,jl), dd_fill, 'I' )
+               ENDIF
+
+               ! compute derivative in j-direction
+               dl_dfdy(:,:,:)=dd_fill
+               IF( il_shape(2) > 1 )THEN
+                  dl_dfdy(:,:,:)=extrap_deriv_3D( dd_value(:,:,:,jl), dd_fill, 'J' )
+               ENDIF
+ 
+               ! compute derivative in k-direction
+               dl_dfdz(:,:,:)=dd_fill
+               IF( il_shape(3) > 1 )THEN
+                  dl_dfdz(:,:,:)=extrap_deriv_3D( dd_value(:,:,:,jl), dd_fill, 'K' )
+               ENDIF
+ 
+               il_dim(1)=2*il_radius+1
+               IF( il_shape(1) < 2*il_radius+1 ) il_dim(1)=1
+               il_dim(2)=2*il_radius+1
+               IF( il_shape(2) < 2*il_radius+1 ) il_dim(2)=1
+               il_dim(3)=2*il_radius+1
+               IF( il_shape(3) < 2*il_radius+1 ) il_dim(3)=1
+
+               ALLOCATE( dl_coef(il_dim(1), il_dim(2), il_dim(3)) ) 
+
+               dl_coef(:,:,:)=extrap__3D_min_error_coef(dd_value( 1:il_dim(1), &
+               &                                                  1:il_dim(2), &
+               &                                                  1:il_dim(3), &
+               &                                                  jl ))
+
+               DO jk=1,il_shape(3)
+                  IF( ALL(il_detect(:,:,jk) == 0) ) CYCLE
+                  DO jj=1,il_shape(2)
+                     IF( ALL(il_detect(:,jj,jk) == 0) ) CYCLE
+                     DO ji=1,il_shape(1)
+
+                        IF( il_detect(ji,jj,jk) == 1 )THEN
+                          
+                           il_imin=MAX(ji-il_radius,1)
+                           il_imax=MIN(ji+il_radius,il_shape(1))
+                           IF( il_dim(1) == 1 )THEN
+                              il_imin=ji
+                              il_imax=ji
+                           ENDIF
+
+                           il_jmin=MAX(jj-il_radius,1)
+                           il_jmax=MIN(jj+il_radius,il_shape(2))
+                           IF( il_dim(2) == 1 )THEN
+                              il_jmin=jj
+                              il_jmax=jj
+                           ENDIF
+
+                           il_kmin=MAX(jk-il_radius,1)
+                           il_kmax=MIN(jk+il_radius,il_shape(3))
+                           IF( il_dim(3) == 1 )THEN
+                              il_kmin=jk
+                              il_kmax=jk
+                           ENDIF
+
+                           dd_value(ji,jj,jk,jl)=extrap__3D_min_error_fill( &
+                           &  dd_value( il_imin:il_imax, &
+                           &            il_jmin:il_jmax, &
+                           &            il_kmin:il_kmax,jl ), dd_fill, il_radius, &
+                           &  dl_dfdx(  il_imin:il_imax, &
+                           &            il_jmin:il_jmax, &
+                           &            il_kmin:il_kmax ), &
+                           &  dl_dfdy(  il_imin:il_imax, &
+                           &            il_jmin:il_jmax, &
+                           &            il_kmin:il_kmax ), &
+                           &  dl_dfdz(  il_imin:il_imax, &
+                           &            il_jmin:il_jmax, &
+                           &            il_kmin:il_kmax ), &
+                           &  dl_coef(:,:,:) )
+
+                           IF( dd_value(ji,jj,jk,jl) /= dd_fill )THEN
+                              il_detect(ji,jj,jk)= 0
+                           ENDIF
+
                         ENDIF
 
-                        il_jmin=MAX(jj-id_ext,1)
-                        il_jmax=MIN(jj+id_ext,il_shape(2))
-                        IF( il_dim(2) == 1 )THEN
-                           il_jmin=jj
-                           il_jmax=jj
-                        ENDIF
-
-                        il_kmin=MAX(jk-id_ext,1)
-                        il_kmax=MIN(jk+id_ext,il_shape(3))
-                        IF( il_dim(3) == 1 )THEN
-                           il_kmin=jk
-                           il_kmax=jk
-                        ENDIF
-
-                        dd_value(ji,jj,jk)=extrap__3D_min_error_fill( &
-                        &  dd_value( il_imin:il_imax, &
-                        &            il_jmin:il_jmax, &
-                        &            il_kmin:il_kmax ), dd_fill, id_ext, &
-                        &  dl_dfdx(  il_imin:il_imax, &
-                        &            il_jmin:il_jmax, &
-                        &            il_kmin:il_kmax ), &
-                        &  dl_dfdy(  il_imin:il_imax, &
-                        &            il_jmin:il_jmax, &
-                        &            il_kmin:il_kmax ), &
-                        &  dl_dfdz(  il_imin:il_imax, &
-                        &            il_jmin:il_jmax, &
-                        &            il_kmin:il_kmax ), &
-                        &  dl_coef(:,:,:) )
-
-                        IF( dd_value(ji,jj,jk) /= dd_fill )THEN
-                           id_detect(ji,jj,jk)= 0
-                        ENDIF
-
-                     ENDIF
-
+                     ENDDO
                   ENDDO
                ENDDO
+
+               DEALLOCATE( dl_dfdx )
+               DEALLOCATE( dl_dfdy )
+               DEALLOCATE( dl_dfdz )
+               DEALLOCATE( dl_coef )
+
+               il_iter=il_iter+1
             ENDDO
-
-            IF( ALLOCATED(dl_dfdx) ) DEALLOCATE( dl_dfdx )
-            IF( ALLOCATED(dl_dfdy) ) DEALLOCATE( dl_dfdy )
-            IF( ALLOCATED(dl_dfdz) ) DEALLOCATE( dl_dfdz )
-            IF( ALLOCATED(dl_coef) ) DEALLOCATE( dl_coef )
-
-         CASE DEFAULT ! 'dist_weight'
-
-            il_dim(1)=2*id_ext+1
-            IF( il_shape(1) < 2*id_ext+1 ) il_dim(1)=1
-            il_dim(2)=2*id_ext+1
-            IF( il_shape(2) < 2*id_ext+1 ) il_dim(2)=1
-            il_dim(3)=2*id_ext+1
-            IF( il_shape(3) < 2*id_ext+1 ) il_dim(3)=1
-            
-            ALLOCATE( dl_coef(il_dim(1), il_dim(2), il_dim(3)) )
-
-            dl_coef(:,:,:)=extrap__3D_dist_weight_coef(dd_value(1:il_dim(1), &
-            &                                                   1:il_dim(2), &
-            &                                                   1:il_dim(3)) )
-
-            DO jk=1,il_shape(3)
-               IF( ALL(id_detect(:,:,jk) == 0) ) CYCLE
-               DO jj=1,il_shape(2)
-                  IF( ALL(id_detect(:,jj,jk) == 0) ) CYCLE
-                  DO ji=1,il_shape(1)
-
-                     IF( id_detect(ji,jj,jk) == 1 )THEN
-                        
-                        il_imin=MAX(ji-id_ext,1)
-                        il_imax=MIN(ji+id_ext,il_shape(1))
-                        IF( il_dim(1) == 1 )THEN
-                           il_imin=ji
-                           il_imax=ji
+         ENDDO
+
+      CASE DEFAULT ! 'dist_weight'
+         DO jl=1,il_shape(4)
+
+            ! intitialise table of poitn to be extrapolated
+            il_detect(:,:,:)=id_detect(:,:,:)
+
+            il_iter=1
+            DO WHILE( ANY(il_detect(:,:,:)==1) )
+               ! change extend value to minimize number of iteration
+               il_radius=id_radius+(il_iter/id_maxiter)
+
+               il_dim(1)=2*il_radius+1
+               IF( il_shape(1) < 2*il_radius+1 ) il_dim(1)=1
+               il_dim(2)=2*il_radius+1
+               IF( il_shape(2) < 2*il_radius+1 ) il_dim(2)=1
+               il_dim(3)=2*il_radius+1
+               IF( il_shape(3) < 2*il_radius+1 ) il_dim(3)=1
+               
+               ALLOCATE( dl_coef(il_dim(1), il_dim(2), il_dim(3)) )
+
+               dl_coef(:,:,:)=extrap__3D_dist_weight_coef(dd_value(1:il_dim(1), &
+               &                                                   1:il_dim(2), &
+               &                                                   1:il_dim(3), &
+               &                                                   jl ) )
+
+               DO jk=1,il_shape(3)
+                  IF( ALL(il_detect(:,:,jk) == 0) ) CYCLE
+                  DO jj=1,il_shape(2)
+                     IF( ALL(il_detect(:,jj,jk) == 0) ) CYCLE
+                     DO ji=1,il_shape(1)
+
+                        IF( il_detect(ji,jj,jk) == 1 )THEN
+                           
+                           il_imin=MAX(ji-il_radius,1)
+                           il_imax=MIN(ji+il_radius,il_shape(1))
+                           IF( il_dim(1) == 1 )THEN
+                              il_imin=ji
+                              il_imax=ji
+                           ENDIF
+
+                           il_jmin=MAX(jj-il_radius,1)
+                           il_jmax=MIN(jj+il_radius,il_shape(2))
+                           IF( il_dim(2) == 1 )THEN
+                              il_jmin=jj
+                              il_jmax=jj
+                           ENDIF
+
+                           il_kmin=MAX(jk-il_radius,1)
+                           il_kmax=MIN(jk+il_radius,il_shape(3))
+                           IF( il_dim(3) == 1 )THEN
+                              il_kmin=jk
+                              il_kmax=jk
+                           ENDIF
+
+                           dd_value(ji,jj,jk,jl)=extrap__3D_dist_weight_fill( &
+                           &  dd_value( il_imin:il_imax, &
+                           &            il_jmin:il_jmax, &
+                           &            il_kmin:il_kmax, &
+                           &            jl), dd_fill, il_radius, &
+                           &  dl_coef(:,:,:) )
+
+                           IF( dd_value(ji,jj,jk,jl) /= dd_fill )THEN
+                              il_detect(ji,jj,jk)= 0
+                           ENDIF
+
                         ENDIF
 
-                        il_jmin=MAX(jj-id_ext,1)
-                        il_jmax=MIN(jj+id_ext,il_shape(2))
-                        IF( il_dim(2) == 1 )THEN
-                           il_jmin=jj
-                           il_jmax=jj
-                        ENDIF
-
-                        il_kmin=MAX(jk-id_ext,1)
-                        il_kmax=MIN(jk+id_ext,il_shape(3))
-                        IF( il_dim(3) == 1 )THEN
-                           il_kmin=jk
-                           il_kmax=jk
-                        ENDIF
-
-                        dd_value(ji,jj,jk)=extrap__3D_dist_weight_fill( &
-                        &  dd_value( il_imin:il_imax, &
-                        &            il_jmin:il_jmax, &
-                        &            il_kmin:il_kmax ), dd_fill, id_ext, &
-                        &  dl_coef(:,:,:) )
-
-                        IF( dd_value(ji,jj,jk) /= dd_fill )THEN
-                           id_detect(ji,jj,jk)= 0
-                        ENDIF
-
-                     ENDIF
-
+                     ENDDO
                   ENDDO
                ENDDO
+
+               DEALLOCATE( dl_coef )
+               il_iter=il_iter+1
             ENDDO
-
-            IF( ALLOCATED(dl_coef) ) DEALLOCATE( dl_coef )
-            
+         ENDDO            
       END SELECT
 
+      DEALLOCATE( il_detect )
+
    END SUBROUTINE extrap__3D
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This function compute derivative of a function in i- and
-   !> j-direction
+   !> This function compute derivative of 1D array.
    !> 
    !> @details 
+   !> optionaly you could specify to take into account east west discontinuity
+   !> (-180° 180° or 0° 360° for longitude variable)
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
+   !> - November, 2013- Initial Version
    !
-   !> @param[in] dd_value : 1D table of variable to be extrapolated
-   !> @param[in] dd_fill : FillValue of variable
-   !> @param[in] cd_dim : compute derivative on first (I) or second (J) dimension 
-   !-------------------------------------------------------------------
-   !> @code
+   !> @param[in] dd_value     1D array of variable to be extrapolated
+   !> @param[in] dd_fill      FillValue of variable
+   !> @param[in] ld_discont   logical to take into account east west discontinuity 
+   !-------------------------------------------------------------------
    PURE FUNCTION extrap_deriv_1D( dd_value, dd_fill, ld_discont )
 
@@ -1003,20 +1056,22 @@
 
    END FUNCTION extrap_deriv_1D
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This function compute derivative of a function in i- and
-   !> j-direction
-   !> 
+   !> This function compute derivative of 2D array.
+   !> you have to specify in which direction derivative have to be computed:
+   !> first (I) or second (J) dimension. 
+   !>
    !> @details 
+   !> optionaly you could specify to take into account east west discontinuity
+   !> (-180° 180° or 0° 360° for longitude variable)
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
+   !> - November, 2013- Initial Version
    !
-   !> @param[in] dd_value : 2D table of variable to be extrapolated
-   !> @param[in] dd_fill : FillValue of variable
-   !> @param[in] cd_dim : compute derivative on first (I) or second (J) dimension 
-   !-------------------------------------------------------------------
-   !> @code
+   !> @param[in] dd_value     2D array of variable to be extrapolated
+   !> @param[in] dd_fill      FillValue of variable
+   !> @param[in] cd_dim       compute derivative on first (I) or second (J) dimension 
+   !> @param[in] ld_discont   logical to take into account east west discontinuity 
+   !-------------------------------------------------------------------
    FUNCTION extrap_deriv_2D( dd_value, dd_fill, cd_dim, ld_discont )
 
@@ -1123,5 +1178,5 @@
             END WHERE
 
-      ENDDO
+         ENDDO
 
       CASE('J')
@@ -1187,20 +1242,22 @@
 
    END FUNCTION extrap_deriv_2D
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This function compute derivative of a function in i- and
-   !> j-direction
+   !> This function compute derivative of 3D array.
+   !> you have to specify in which direction derivative have to be computed:
+   !> first (I), second (J) or third (K) dimension.
    !> 
    !> @details 
+   !> optionaly you could specify to take into account east west discontinuity
+   !> (-180° 180° or 0° 360° for longitude variable)
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
+   !> - November, 2013- Initial Version
    !
-   !> @param[inout] dd_value : 3D table of variable to be extrapolated
-   !> @param[in] dd_fill : FillValue of variable
-   !> @param[in] cd_dim : compute derivative on first (I) second (J) or third (K) dimension   
-   !-------------------------------------------------------------------
-   !> @code
+   !> @param[inout] dd_value  3D array of variable to be extrapolated
+   !> @param[in] dd_fill      FillValue of variable
+   !> @param[in] cd_dim       compute derivative on first (I) second (J) or third (K) dimension   
+   !> @param[in] ld_discont   logical to take into account east west discontinuity
+   !-------------------------------------------------------------------
    PURE FUNCTION extrap_deriv_3D( dd_value, dd_fill, cd_dim, ld_discont )
 
@@ -1431,26 +1488,18 @@
 
    END FUNCTION extrap_deriv_3D
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This function compute extrapolatd values by calculated minimum error using
-   !> taylor expansion
+   !> This function compute coefficient for min_error extrapolation.
    !> 
    !> @details 
+   !> coefficients are  "grid distance" to the center of the box choosed to compute
+   !> extrapolation.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
+   !> - November, 2013- Initial Version
    !
-   !> @param[in] dd_value : 3D table of variable to be extrapolated
-   !> @param[in] dd_fill : FillValue of variable
-   !> @param[in] dd_ideriv : derivative of function in i-direction
-   !> @param[in] dd_jderiv : derivative of function in j-direction
-   !> @param[in] dd_kderiv : derivative of function in k-direction
-   !> @param[in] id_ji  : i-direction indices table
-   !> @param[in] id_jj  : j-direction indices table 
-   !> @param[in] id_ii  : i-direction indices of the point to extrapolate 
-   !> @param[in] id_ij  : j-direction indices of the point to extrapolate
-   !-------------------------------------------------------------------
-   !> @code
+   !> @param[in] dd_value  3D array of variable to be extrapolated
+   !> @return 3D array of coefficient for minimum error extrapolation
+   !-------------------------------------------------------------------
    PURE FUNCTION extrap__3D_min_error_coef( dd_value )
 
@@ -1514,24 +1563,22 @@
 
    END FUNCTION extrap__3D_min_error_coef
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This function compute extrapolatd values by calculated minimum error using
+   !> This function compute extrapolatd value by calculated minimum error using
    !> taylor expansion
    !> 
-   !> @details 
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
    !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] dd_value : 3D table of variable to be extrapolated
-   !> @param[in] dd_fill : FillValue of variable
-   !> @param[in] dd_dfdx : derivative of function in i-direction
-   !> @param[in] dd_dfdy : derivative of function in j-direction
-   !> @param[in] dd_dfdz : derivative of function in k-direction
-   !> @param[in] dd_coef : 
-   !-------------------------------------------------------------------
-   !> @code
-   PURE FUNCTION extrap__3D_min_error_fill( dd_value, dd_fill, id_ext, &
+   !> @param[in] dd_value  3D array of variable to be extrapolated
+   !> @param[in] dd_fill   FillValue of variable
+   !> @param[in] id_radius radius of the halo used to compute extrapolation
+   !> @param[in] dd_dfdx   derivative of function in i-direction
+   !> @param[in] dd_dfdy   derivative of function in j-direction
+   !> @param[in] dd_dfdz   derivative of function in k-direction
+   !> @param[in] dd_coef   array of coefficient for min_error extrapolation 
+   !> @return extrapolatd value
+   !-------------------------------------------------------------------
+   PURE FUNCTION extrap__3D_min_error_fill( dd_value, dd_fill, id_radius, &
    &                                        dd_dfdx, dd_dfdy, dd_dfdz, &
    &                                        dd_coef )
@@ -1540,5 +1587,5 @@
       REAL(dp)   , DIMENSION(:,:,:), INTENT(IN) :: dd_value
       REAL(dp)   ,                   INTENT(IN) :: dd_fill
-      INTEGER(i4),                   INTENT(IN) :: id_ext
+      INTEGER(i4),                   INTENT(IN) :: id_radius
       REAL(dp)   , DIMENSION(:,:,:), INTENT(IN) :: dd_dfdx
       REAL(dp)   , DIMENSION(:,:,:), INTENT(IN) :: dd_dfdy
@@ -1564,5 +1611,5 @@
       extrap__3D_min_error_fill=dd_fill
 
-      il_min=MAX(1,(SIZE(dd_value(:,:,:)))/(1+id_ext*2))
+      il_min=MAX(1,(SIZE(dd_value(:,:,:)))/(1+id_radius*2))
 
       IF( COUNT(dd_value(:,:,:) /= dd_fill) >= il_min )THEN
@@ -1602,18 +1649,18 @@
 
    END FUNCTION extrap__3D_min_error_fill
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This function compute extrapolatd values by calculated minimum error using
-   !> taylor expansion
+   !> This function compute coefficient for inverse distance weighted method 
    !> 
    !> @details 
+   !> coefficients are inverse "grid distance" to the center of the box choosed to compute
+   !> extrapolation.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
+   !> - November, 2013- Initial Version
    !
-   !> @param[in] dd_value : 3D table of variable to be extrapolated
-   !-------------------------------------------------------------------
-   !> @code
+   !> @param[in] dd_value  3D array of variable to be extrapolated
+   !> @return 3D array of coefficient for inverse distance weighted extrapolation
+   !-------------------------------------------------------------------
    PURE FUNCTION extrap__3D_dist_weight_coef( dd_value )
 
@@ -1677,27 +1724,27 @@
 
    END FUNCTION extrap__3D_dist_weight_coef
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This function compute extrapolatd values by calculated minimum error using
-   !> taylor expansion
+   !> This function compute extrapolatd value using inverse distance weighted
+   !> method
    !> 
    !> @details 
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
+   !> - November, 2013- Initial Version
    !
-   !> @param[in] dd_value : 3D table of variable to be extrapolated
-   !> @param[in] dd_fill : FillValue of variable
-   !> @param[in] dd_coef :  
-   !-------------------------------------------------------------------
-   !> @code
-   FUNCTION extrap__3D_dist_weight_fill( dd_value, dd_fill, id_ext, &
-   &                                          dd_coef )
+   !> @param[in] dd_value  3D array of variable to be extrapolated
+   !> @param[in] dd_fill   FillValue of variable
+   !> @param[in] id_radius radius of the halo used to compute extrapolation
+   !> @param[in] dd_coef   3D array of coefficient for inverse distance weighted extrapolation 
+   !> @return extrapolatd value
+   !-------------------------------------------------------------------
+   FUNCTION extrap__3D_dist_weight_fill( dd_value, dd_fill, id_radius, &
+   &                                     dd_coef )
       IMPLICIT NONE
       ! Argument
       REAL(dp)   , DIMENSION(:,:,:), INTENT(IN) :: dd_value
       REAL(dp)   ,                   INTENT(IN) :: dd_fill
-      INTEGER(i4),                   INTENT(IN) :: id_ext
+      INTEGER(i4),                   INTENT(IN) :: id_radius
       REAL(dp)   , DIMENSION(:,:,:), INTENT(IN) :: dd_coef
 
@@ -1722,5 +1769,5 @@
       extrap__3D_dist_weight_fill=dd_fill
 
-      il_min=MAX(1,(SIZE(dd_value(:,:,:)))/(1+id_ext*2))
+      il_min=MAX(1,(SIZE(dd_value(:,:,:)))/(1+id_radius*2))
 
       IF( COUNT(dd_value(:,:,:)/= dd_fill) >= il_min )THEN
@@ -1733,18 +1780,22 @@
          dl_coef(:,:,:)=0
 
-         FORALL( ji=1:il_shape(1), &
-         &       jj=1:il_shape(2), &
-         &       jk=1:il_shape(3), &
-         &       dd_value(ji,jj,jk) /= dd_fill )
-
-            ! compute factor
-            dl_value(ji,jj,jk)=dd_coef(ji,jj,jk)*dd_value(ji,jj,jk)
-            dl_coef(ji,jj,jk)=dd_coef(ji,jj,jk)
-
-         END FORALL
+         DO jk=1,il_shape(3)
+            DO jj=1,il_shape(2)
+               DO ji=1,il_shape(1)
+
+                  IF( dd_value(ji,jj,jk) /= dd_fill )THEN
+                     ! compute factor
+                     dl_value(ji,jj,jk)=dd_coef(ji,jj,jk)*dd_value(ji,jj,jk)
+                     dl_coef(ji,jj,jk)=dd_coef(ji,jj,jk)
+                  ENDIF
+
+               ENDDO
+            ENDDO
+         ENDDO
 
          ! return value
          IF( SUM( dl_coef(:,:,:) ) /= 0 )THEN
-            extrap__3D_dist_weight_fill=SUM( dl_value(:,:,:) )/SUM( dl_coef(:,:,:) )
+            extrap__3D_dist_weight_fill = &
+            &  SUM( dl_value(:,:,:) )/SUM( dl_coef(:,:,:) )
          ENDIF
 
@@ -1755,5 +1806,4 @@
 
    END FUNCTION extrap__3D_dist_weight_fill
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
